feat(density): Delete ipsec nfv_density tests
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2024 Cisco and/or its affiliates.
2 # Copyright (c) 2024 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_alt" | "1n_spr")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     parse_env_variables || die "Parse of environment variables failed!"
83
84     # Replace all variables in template with those in environment.
85     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
86         die "Topology file create failed!"
87     }
88
89     WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
90     mv topo.yml "${WORKING_TOPOLOGY}" || {
91         die "Topology move failed!"
92     }
93     cat ${WORKING_TOPOLOGY} | grep -v password || {
94         die "Topology read failed!"
95     }
96
97     # Subfunctions to update data that may depend on topology reserved.
98     set_environment_variables || die
99     select_tags || die
100     compose_robot_arguments || die
101
102 }
103
104
105 function activate_virtualenv () {
106
107     # Update virtualenv pip package, delete and create virtualenv directory,
108     # activate the virtualenv, install requirements, set PYTHONPATH.
109
110     # Arguments:
111     # - ${1} - Path to existing directory for creating virtualenv in.
112     #          If missing or empty, ${CSIT_DIR} is used.
113     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
114     # Variables read:
115     # - CSIT_DIR - Path to existing root of local CSIT git repository.
116     # Variables exported:
117     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
118     # Functions called:
119     # - die - Print to stderr and exit.
120
121     set -exuo pipefail
122
123     root_path="${1-$CSIT_DIR}"
124     env_dir="${root_path}/env"
125     req_path=${2-$CSIT_DIR/requirements.txt}
126     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
127     pip3 install virtualenv==20.15.1 || {
128         die "Virtualenv package install failed."
129     }
130     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
131         die "Virtualenv creation for $(which python3) failed."
132     }
133     set +u
134     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
135     set -u
136     pip3 install -r "${req_path}" || {
137         die "Requirements installation failed."
138     }
139     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
140     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
141 }
142
143
144 function archive_tests () {
145
146     # Create .tar.gz of generated/tests for archiving.
147     # To be run after generate_tests, kept separate to offer more flexibility.
148
149     # Directory read:
150     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
151     # File rewriten:
152     # - ${ARCHIVE_DIR}/generated_tests.tar.gz - Archive of generated tests.
153
154     set -exuo pipefail
155
156     pushd "${ARCHIVE_DIR}" || die
157     tar czf "generated_tests.tar.gz" "${GENERATED_DIR}/tests" || true
158     popd || die
159 }
160
161
162 function check_download_dir () {
163
164     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
165     #
166     # Variables read:
167     # - DOWNLOAD_DIR - Path to directory robot takes the build to test from.
168     # Directories read:
169     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
170     # Functions called:
171     # - die - Print to stderr and exit.
172
173     set -exuo pipefail
174
175     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
176         die "No artifacts downloaded!"
177     fi
178 }
179
180
181 function check_prerequisites () {
182
183     # Fail if prerequisites are not met.
184     #
185     # Functions called:
186     # - installed - Check if application is installed/present in system.
187     # - die - Print to stderr and exit.
188
189     set -exuo pipefail
190
191     if ! installed sshpass; then
192         die "Please install sshpass before continue!"
193     fi
194 }
195
196
197 function common_dirs () {
198
199     # Set global variables, create some directories (without touching content).
200
201     # Variables set:
202     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
203     # - CSIT_DIR - Path to existing root of local CSIT git repository.
204     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
205     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
206     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
207     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
208     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
209     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
210     #   The name is chosen to match what ci-management expects.
211     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
212     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
213     # Directories created if not present:
214     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
215     # Functions called:
216     # - die - Print to stderr and exit.
217
218     set -exuo pipefail
219
220     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
221         die "Some error during locating of this source file."
222     }
223     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
224         die "Some error during dirname call."
225     }
226     # Current working directory could be in a different repo, e.g. VPP.
227     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
228     relative_csit_dir=$(git rev-parse --show-toplevel) || {
229         die "Git rev-parse failed."
230     }
231     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
232     popd || die "Popd failed."
233     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
234         die "Readlink failed."
235     }
236     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/resources/job_specs") || {
237         die "Readlink failed."
238     }
239     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
240         die "Readlink failed."
241     }
242     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
243         die "Readlink failed."
244     }
245     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
246         die "Readlink failed."
247     }
248
249     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
250         die "Readlink failed."
251     }
252     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
253     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
254         die "Readlink failed."
255     }
256     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
257     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
258         die "Readlink failed."
259     }
260     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
261 }
262
263
264 function compose_robot_arguments () {
265
266     # This function is called by run_tests function.
267     # The reason is that some jobs (bisect) perform reservation multiple times,
268     # so WORKING_TOPOLOGY can be different each time.
269     #
270     # Variables read:
271     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
272     # - DUT - CSIT test/ subdirectory, set while processing tags.
273     # - TAGS - Array variable holding selected tag boolean expressions.
274     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
275     # - TEST_CODE - The test selection string from environment or argument.
276     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
277     # Variables set:
278     # - ROBOT_ARGS - String holding part of all arguments for robot.
279     # - EXPANDED_TAGS - Array of strings robot arguments compiled from tags.
280
281     set -exuo pipefail
282
283     # No explicit check needed with "set -u".
284     ROBOT_ARGS=("--loglevel" "TRACE")
285     ROBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
286
287     # TODO: The rest does not need to be recomputed on each reservation.
288     #       Refactor TEST_CODE so this part can be called only once.
289     case "${TEST_CODE}" in
290         *"device"*)
291             ROBOT_ARGS+=("--suite" "tests.${DUT}.device")
292             ;;
293         *"perf"* | *"bisect"*)
294             ROBOT_ARGS+=("--suite" "tests.${DUT}.perf")
295             ;;
296         *)
297             die "Unknown specification: ${TEST_CODE}"
298     esac
299
300     EXPANDED_TAGS=()
301     for tag in "${TAGS[@]}"; do
302         if [[ ${tag} == "!"* ]]; then
303             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
304         else
305             if [[ ${SELECTION_MODE} == "--test" ]]; then
306                 EXPANDED_TAGS+=("--test" "${tag}")
307             else
308                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
309             fi
310         fi
311     done
312
313     if [[ ${SELECTION_MODE} == "--test" ]]; then
314         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
315     fi
316 }
317
318
319 function deactivate_docker_topology () {
320
321     # Deactivate virtual vpp-device topology by removing containers.
322     #
323     # Variables read:
324     # - NODENESS - Node multiplicity of desired testbed.
325     # - FLAVOR - Node flavor string, usually describing the processor.
326
327     set -exuo pipefail
328
329     case_text="${NODENESS}_${FLAVOR}"
330     case "${case_text}" in
331         "1n_skx" | "1n_alt" | "1n_spr")
332             ssh="ssh root@172.17.0.1 -p 6022"
333             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
334             # The "declare -f" output is long and boring.
335             set +x
336             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
337                 die "Topology cleanup via shim-dcr failed!"
338             }
339             set -x
340             ;;
341         "1n_vbox")
342             enter_mutex || die
343             clean_environment || {
344                 die "Topology cleanup locally failed!"
345             }
346             exit_mutex || die
347             ;;
348         *)
349             die "Unknown specification: ${case_text}!"
350     esac
351 }
352
353
354 function die () {
355
356     # Print the message to standard error end exit with error code specified
357     # by the second argument.
358     #
359     # Hardcoded values:
360     # - The default error message.
361     # Arguments:
362     # - ${1} - The whole error message, be sure to quote. Optional
363     # - ${2} - the code to exit with, default: 1.
364
365     set -x
366     set +eu
367     warn "${1:-Unspecified run-time error occurred!}"
368     exit "${2:-1}"
369 }
370
371
372 function die_on_robot_error () {
373
374     # Source this fragment if you want to abort on any failed test case.
375     #
376     # Variables read:
377     # - ROBOT_EXIT_STATUS - Set by a robot running fragment.
378     # Functions called:
379     # - die - Print to stderr and exit.
380
381     set -exuo pipefail
382
383     if [[ "${ROBOT_EXIT_STATUS}" != "0" ]]; then
384         die "Test failures are present!" "${ROBOT_EXIT_STATUS}"
385     fi
386 }
387
388
389 function generate_tests () {
390
391     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
392     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
393     # The generation is done by executing any *.py executable
394     # within any subdirectory after copying.
395
396     # This is a separate function, because this code is called
397     # both by autogen checker and entries calling run_robot.
398
399     # Directories read:
400     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
401     # Directories replaced:
402     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
403
404     set -exuo pipefail
405
406     rm -rf "${GENERATED_DIR}/tests" || die
407     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
408     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
409     cmd_line+=("-executable" "-name" "*.py")
410     # We sort the directories, so log output can be compared between runs.
411     file_list=$("${cmd_line[@]}" | sort) || die
412
413     for gen in ${file_list}; do
414         directory="$(dirname "${gen}")" || die
415         filename="$(basename "${gen}")" || die
416         pushd "${directory}" || die
417         ./"${filename}" || die
418         popd || die
419     done
420 }
421
422
423 function get_test_code () {
424
425     # Arguments:
426     # - ${1} - Optional, argument of entry script (or empty as unset).
427     #   Test code value to override job name from environment.
428     # Variables read:
429     # - JOB_NAME - String affecting test selection, default if not argument.
430     # Variables set:
431     # - TEST_CODE - The test selection string from environment or argument.
432     # - NODENESS - Node multiplicity of desired testbed.
433     # - FLAVOR - Node flavor string, usually describing the processor.
434
435     set -exuo pipefail
436
437     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
438     if [[ -z "${TEST_CODE}" ]]; then
439         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
440     fi
441
442     case "${TEST_CODE}" in
443         *"1n-vbox")
444             NODENESS="1n"
445             FLAVOR="vbox"
446             ;;
447         *"1n-skx")
448             NODENESS="1n"
449             FLAVOR="skx"
450             ;;
451         *"1n-spr")
452             NODENESS="1n"
453             FLAVOR="spr"
454             ;;
455         *"1n-alt")
456             NODENESS="1n"
457             FLAVOR="alt"
458             ;;
459         *"1n-aws")
460             NODENESS="1n"
461             FLAVOR="aws"
462             ;;
463         *"2n-aws")
464             NODENESS="2n"
465             FLAVOR="aws"
466             ;;
467         *"3n-aws")
468             NODENESS="3n"
469             FLAVOR="aws"
470             ;;
471         *"2n-c7gn")
472             NODENESS="2n"
473             FLAVOR="c7gn"
474             ;;
475         *"3n-c7gn")
476             NODENESS="3n"
477             FLAVOR="c7gn"
478             ;;
479         *"1n-c6in")
480             NODENESS="1n"
481             FLAVOR="c6in"
482             ;;
483         *"2n-c6in")
484             NODENESS="2n"
485             FLAVOR="c6in"
486             ;;
487         *"3n-c6in")
488             NODENESS="3n"
489             FLAVOR="c6in"
490             ;;
491         *"2n-zn2")
492             NODENESS="2n"
493             FLAVOR="zn2"
494             ;;
495         *"2n-clx")
496             NODENESS="2n"
497             FLAVOR="clx"
498             ;;
499         *"2n-icx")
500             NODENESS="2n"
501             FLAVOR="icx"
502             ;;
503         *"2n-spr")
504             NODENESS="2n"
505             FLAVOR="spr"
506             ;;
507         *"3n-icx")
508             NODENESS="3n"
509             FLAVOR="icx"
510             ;;
511         *"3na-spr")
512             NODENESS="3na"
513             FLAVOR="spr"
514             ;;
515         *"3nb-spr")
516             NODENESS="3nb"
517             FLAVOR="spr"
518             ;;
519         *"3n-snr")
520             NODENESS="3n"
521             FLAVOR="snr"
522             ;;
523         *"3n-icxd")
524             NODENESS="3n"
525             FLAVOR="icxd"
526             ;;
527         *"2n-tx2")
528             NODENESS="2n"
529             FLAVOR="tx2"
530             ;;
531         *"3n-tsh")
532             NODENESS="3n"
533             FLAVOR="tsh"
534             ;;
535         *"3n-alt")
536             NODENESS="3n"
537             FLAVOR="alt"
538             ;;
539         *"2n-x-"*)
540             NODENESS="2n"
541             FLAVOR="${TEST_CODE#*2n-}"
542             ;;
543         *"3n-x-"*)
544             NODENESS="3n"
545             FLAVOR="${TEST_CODE#*3n-}"
546             ;;
547     esac
548 }
549
550
551 function get_test_tag_string () {
552
553     # Variables read:
554     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
555     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
556     # - TEST_CODE - The test selection string from environment or argument.
557     # Variables set:
558     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
559     #   May be empty, or even not set on event types not adding comment.
560     # - GIT_BISECT_FROM - If bisecttest, the commit hash to bisect from.
561     #   Else not set.
562     # Variables exported optionally:
563     # - GRAPH_NODE_VARIANT - Node variant to test with, set if found in trigger.
564
565     # TODO: ci-management scripts no longer need to perform this.
566
567     set -exuo pipefail
568
569     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
570         case "${TEST_CODE}" in
571             # Order matters, bisect job contains "perf" in its name.
572             *"bisect"*)
573                 trigger="bisecttest"
574                 ;;
575             *"device"*)
576                 trigger="devicetest"
577                 ;;
578             *"perf"*)
579                 trigger="perftest"
580                 ;;
581             *)
582                 die "Unknown specification: ${TEST_CODE}"
583         esac
584         # Ignore lines not containing the trigger word.
585         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
586         # The vpp-csit triggers trail stuff we are not interested in.
587         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
588         # (except relying on \s whitespace, \S non-whitespace and . both).
589         # The last string is concatenated, only the middle part is expanded.
590         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
591         # On parsing error, TEST_TAG_STRING probably stays empty.
592         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
593         if [[ -z "${TEST_TAG_STRING-}" ]]; then
594             # Probably we got a base64 encoded comment.
595             comment="${GERRIT_EVENT_COMMENT_TEXT}"
596             comment=$(base64 --decode <<< "${comment}" || true)
597             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
598             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
599         fi
600         if [[ "${trigger}" == "bisecttest" ]]; then
601             # Intentionally without quotes, so spaces delimit elements.
602             test_tag_array=(${TEST_TAG_STRING}) || die "How could this fail?"
603             # First "argument" of bisecttest is a commit hash.
604             GIT_BISECT_FROM="${test_tag_array[0]}" || {
605                 die "Bisect job requires commit hash."
606             }
607             # Update the tag string (tag expressions only, no commit hash).
608             TEST_TAG_STRING="${test_tag_array[@]:1}" || {
609                 die "Bisect job needs a single test, no default."
610             }
611         fi
612         if [[ -n "${TEST_TAG_STRING-}" ]]; then
613             test_tag_array=(${TEST_TAG_STRING})
614             if [[ "${test_tag_array[0]}" == "icl" ]]; then
615                 export GRAPH_NODE_VARIANT="icl"
616                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
617             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
618                 export GRAPH_NODE_VARIANT="skx"
619                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
620             fi
621         fi
622     fi
623 }
624
625
626 function installed () {
627
628     # Check if the given utility is installed. Fail if not installed.
629     #
630     # Duplicate of common.sh function, as this file is also used standalone.
631     #
632     # Arguments:
633     # - ${1} - Utility to check.
634     # Returns:
635     # - 0 - If command is installed.
636     # - 1 - If command is not installed.
637
638     set -exuo pipefail
639
640     command -v "${1}"
641 }
642
643
644 function move_archives () {
645
646     # Move archive directory to top of workspace, if not already there.
647     #
648     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
649     # but in some jobs CSIT_DIR is not same as WORKSPACE
650     # (e.g. under VPP_DIR). To simplify ci-management settings,
651     # we want to move the data to the top. We do not want simple copy,
652     # as ci-management is eager with recursive search.
653     #
654     # As some scripts may call this function multiple times,
655     # the actual implementation use copying and deletion,
656     # so the workspace gets "union" of contents (except overwrites on conflict).
657     # The consequence is empty ARCHIVE_DIR remaining after this call.
658     #
659     # As the source directory is emptied,
660     # the check for dirs being different is essential.
661     #
662     # Variables read:
663     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
664     #   Can be unset, then it speeds up manual testing.
665     # - ARCHIVE_DIR - Path to directory with content to be moved.
666     # Directories updated:
667     # - ${WORKSPACE}/archives/ - Created if does not exist.
668     #   Content of ${ARCHIVE_DIR}/ is moved.
669     # Functions called:
670     # - die - Print to stderr and exit.
671
672     set -exuo pipefail
673
674     if [[ -n "${WORKSPACE-}" ]]; then
675         target=$(readlink -f "${WORKSPACE}/archives")
676         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
677             mkdir -p "${target}" || die "Archives dir create failed."
678             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
679             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
680         fi
681     fi
682 }
683
684
685 function prepare_topology () {
686
687     # Prepare virtual testbed topology if needed based on flavor.
688
689     # Variables read:
690     # - TEST_CODE - String affecting test selection, usually jenkins job name.
691     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
692     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
693     # Variables set:
694     # - TERRAFORM_MODULE_DIR - Terraform module directory.
695     # Functions called:
696     # - die - Print to stderr and exit.
697     # - terraform_init - Terraform init topology.
698     # - terraform_apply - Terraform apply topology.
699
700     set -exuo pipefail
701
702     case_text="${NODENESS}_${FLAVOR}"
703     case "${case_text}" in
704         "1n_aws" | "2n_aws" | "3n_aws")
705             export TF_VAR_testbed_name="${TEST_CODE}"
706             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
707             terraform_init || die "Failed to call terraform init."
708             trap "terraform_destroy" ERR EXIT || {
709                 die "Trap attempt failed, please cleanup manually. Aborting!"
710             }
711             terraform_apply || die "Failed to call terraform apply."
712             ;;
713         "2n_c7gn" | "3n_c7gn")
714             export TF_VAR_testbed_name="${TEST_CODE}"
715             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c7gn"
716             terraform_init || die "Failed to call terraform init."
717             trap "terraform_destroy" ERR EXIT || {
718                 die "Trap attempt failed, please cleanup manually. Aborting!"
719             }
720             terraform_apply || die "Failed to call terraform apply."
721             ;;
722         "1n_c6in" | "2n_c6in" | "3n_c6in")
723             export TF_VAR_testbed_name="${TEST_CODE}"
724             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c6in"
725             terraform_init || die "Failed to call terraform init."
726             trap "terraform_destroy" ERR EXIT || {
727                 die "Trap attempt failed, please cleanup manually. Aborting!"
728             }
729             terraform_apply || die "Failed to call terraform apply."
730             ;;
731     esac
732 }
733
734
735 function reserve_and_cleanup_testbed () {
736
737     # Reserve physical testbed, perform cleanup, register trap to unreserve.
738     # When cleanup fails, remove from topologies and keep retrying
739     # until all topologies are removed.
740     #
741     # Multiple other functions are called from here,
742     # as they set variables that depend on reserved topology data.
743     #
744     # Variables read:
745     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
746     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
747     # - BUILD_TAG - Any string suitable as filename, identifying
748     #   test run executing this function. May be unset.
749     # Variables set:
750     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
751     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
752     # Functions called:
753     # - die - Print to stderr and exit.
754     # - ansible_playbook - Perform an action using ansible, see ansible.sh
755     # Traps registered:
756     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
757
758     set -exuo pipefail
759
760     while true; do
761         for topo in "${TOPOLOGIES[@]}"; do
762             set +e
763             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
764             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
765             python3 "${scrpt}" "${opts[@]}"
766             result="$?"
767             set -e
768             if [[ "${result}" == "0" ]]; then
769                 # Trap unreservation before cleanup check,
770                 # so multiple jobs showing failed cleanup improve chances
771                 # of humans to notice and fix.
772                 WORKING_TOPOLOGY="${topo}"
773                 echo "Reserved: ${WORKING_TOPOLOGY}"
774                 trap "untrap_and_unreserve_testbed" EXIT || {
775                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
776                     untrap_and_unreserve_testbed "${message}" || {
777                         die "Teardown should have died, not failed."
778                     }
779                     die "Trap attempt failed, unreserve succeeded. Aborting."
780                 }
781                 # Cleanup + calibration checks
782                 set +e
783                 ansible_playbook "cleanup, calibration"
784                 result="$?"
785                 set -e
786                 if [[ "${result}" == "0" ]]; then
787                     break
788                 fi
789                 warn "Testbed cleanup failed: ${topo}"
790                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
791             fi
792             # Else testbed is accessible but currently reserved, moving on.
793         done
794
795         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
796             # Exit the infinite while loop if we made a reservation.
797             warn "Reservation and cleanup successful."
798             break
799         fi
800
801         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
802             die "Run out of operational testbeds!"
803         fi
804
805         # Wait ~3minutes before next try.
806         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
807             die "Sleep time calculation failed."
808         }
809         echo "Sleeping ${sleep_time}"
810         sleep "${sleep_time}" || die "Sleep failed."
811     done
812
813     # Subfunctions to update data that may depend on topology reserved.
814     set_environment_variables || die
815     select_tags || die
816     compose_robot_arguments || die
817 }
818
819
820 function run_robot () {
821
822     # Run robot with options based on input variables.
823     #
824     # Testbed has to be reserved already,
825     # as some data may have changed between reservations,
826     # for example excluded NICs.
827     #
828     # Variables read:
829     # - CSIT_DIR - Path to existing root of local CSIT git repository.
830     # - ARCHIVE_DIR - Path to store robot result files in.
831     # - ROBOT_ARGS, EXPANDED_TAGS - See compose_robot_arguments.sh
832     # - GENERATED_DIR - Tests are assumed to be generated under there.
833     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
834     # - DUT - CSIT test/ subdirectory, set while processing tags.
835     # - TAGS - Array variable holding selected tag boolean expressions.
836     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
837     # - TEST_CODE - The test selection string from environment or argument.
838     # Variables set:
839     # - ROBOT_ARGS - String holding part of all arguments for robot.
840     # - EXPANDED_TAGS - Array of string robot arguments compiled from tags.
841     # - ROBOT_EXIT_STATUS - Exit status of most recent robot invocation.
842     # Functions called:
843     # - die - Print to stderr and exit.
844
845     set -exuo pipefail
846
847     all_options=("--outputdir" "${ARCHIVE_DIR}" "${ROBOT_ARGS[@]}")
848     all_options+=("${EXPANDED_TAGS[@]}")
849
850     pushd "${CSIT_DIR}" || die "Change directory operation failed."
851     set +e
852     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
853     ROBOT_EXIT_STATUS="$?"
854     set -e
855
856     popd || die "Change directory operation failed."
857 }
858
859
860 function select_arch_os () {
861
862     # Set variables affected by local CPU architecture and operating system.
863     #
864     # Variables set:
865     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
866     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
867     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
868
869     set -exuo pipefail
870
871     source /etc/os-release || die "Get OS release failed."
872
873     case "${ID}" in
874         "ubuntu"*)
875             case "${VERSION}" in
876                 *"LTS (Jammy Jellyfish)"*)
877                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU_JAMMY"
878                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_JAMMY"
879                     PKG_SUFFIX="deb"
880                     ;;
881                 *)
882                     die "Unsupported Ubuntu version!"
883                     ;;
884             esac
885             ;;
886         *)
887             die "Unsupported distro or OS!"
888             ;;
889     esac
890
891     arch=$(uname -m) || {
892         die "Get CPU architecture failed."
893     }
894
895     case "${arch}" in
896         "aarch64")
897             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
898             ;;
899         *)
900             ;;
901     esac
902 }
903
904
905 function select_tags () {
906
907     # Only to be called from the reservation function,
908     # as resulting tags may change based on topology data.
909     #
910     # Variables read:
911     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
912     # - TEST_CODE - String affecting test selection, usually jenkins job name.
913     # - DUT - CSIT test/ subdirectory, set while processing tags.
914     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
915     #   Can be unset.
916     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
917     # - BASH_FUNCTION_DIR - Directory with input files to process.
918     # Variables set:
919     # - TAGS - Array of processed tag boolean expressions.
920     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
921
922     set -exuo pipefail
923
924     # NIC SELECTION
925     case "${TEST_CODE}" in
926         *"1n-aws"* | *"1n-c6in"*)
927             start_pattern='^  SUT:'
928             ;;
929         *)
930             start_pattern='^  TG:'
931             ;;
932     esac
933     end_pattern='^ \? \?[A-Za-z0-9]\+:'
934     # Remove the sections from topology file
935     sed_command="/${start_pattern}/,/${end_pattern}/d"
936     # All topologies NICs
937     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
938                 | grep -hoP "model: \K.*" | sort -u)
939     # Selected topology NICs
940     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
941                | grep -hoP "model: \K.*" | sort -u)
942     # All topologies NICs - Selected topology NICs
943     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
944         die "Computation of excluded NICs failed."
945     }
946
947     # Select default NIC tag.
948     case "${TEST_CODE}" in
949         *"3n-snr")
950             default_nic="nic_intel-e822cq"
951             ;;
952         *"3n-icxd")
953             default_nic="nic_intel-e823c"
954             ;;
955         *"3n-tsh")
956             default_nic="nic_intel-x520-da2"
957             ;;
958         *"3n-icx" | *"2n-icx")
959             default_nic="nic_intel-e810cq"
960             ;;
961         *"3na-spr")
962             default_nic="nic_mellanox-cx7veat"
963             ;;
964         *"3nb-spr")
965             default_nic="nic_intel-e810cq"
966             ;;
967         *"2n-spr")
968             default_nic="nic_intel-e810cq"
969             ;;
970         *"2n-clx" | *"2n-zn2")
971             default_nic="nic_intel-xxv710"
972             ;;
973         *"2n-tx2" | *"3n-alt")
974             default_nic="nic_intel-xl710"
975             ;;
976         *"1n-aws" | *"2n-aws" | *"3n-aws")
977             default_nic="nic_amazon-nitro-50g"
978             ;;
979         *"2n-c7gn" | *"3n-c7gn")
980             default_nic="nic_amazon-nitro-100g"
981             ;;
982         *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
983             default_nic="nic_amazon-nitro-200g"
984             ;;
985         *"2n-x-"* | *"3n-x-"*)
986             default_nic="nic_intel-e810cq"
987             ;;
988         *)
989             default_nic="nic_intel-x710"
990             ;;
991     esac
992
993     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
994     awk_nics_sub_cmd=""
995     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
996     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
997     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
998     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
999     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
1000     awk_nics_sub_cmd+='gsub("2p1cx7veat","200ge2p1cx7veat");'
1001     awk_nics_sub_cmd+='gsub("6p3cx7veat","200ge6p3cx7veat");'
1002     awk_nics_sub_cmd+='gsub("cx6dx","100ge2p1cx6dx");'
1003     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
1004     awk_nics_sub_cmd+='gsub("e822cq","25ge2p1e822cq");'
1005     awk_nics_sub_cmd+='gsub("e823c","25ge2p1e823c");'
1006     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
1007     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
1008     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
1009     awk_nics_sub_cmd+='gsub("nitro-100g","100ge1p1ENA");'
1010     awk_nics_sub_cmd+='gsub("nitro-200g","200ge1p1ENA");'
1011     awk_nics_sub_cmd+='gsub("virtual","1ge1p82540em");'
1012     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
1013     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
1014     awk_nics_sub_cmd+='else if ($9 =="drv_mlx5_core") drv ="mlx5-";'
1015     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
1016     awk_nics_sub_cmd+='else drv="";'
1017     awk_nics_sub_cmd+='if ($1 =="-") cores="";'
1018     awk_nics_sub_cmd+='else cores=$1;'
1019     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
1020
1021     # Tag file directory shorthand.
1022     tfd="${JOB_SPECS_DIR}"
1023     case "${TEST_CODE}" in
1024         # Select specific performance tests based on jenkins job type variable.
1025         *"device"* )
1026             readarray -t test_tag_array <<< $(grep -v "#" \
1027                 ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
1028                 awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
1029             SELECTION_MODE="--test"
1030             ;;
1031         *"hoststack-daily"* )
1032             readarray -t test_tag_array <<< $(grep -v "#" \
1033                 ${tfd}/hoststack_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
1034                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1035             SELECTION_MODE="--test"
1036             ;;
1037         *"ndrpdr-weekly"* )
1038             readarray -t test_tag_array <<< $(grep -v "#" \
1039                 ${tfd}/ndrpdr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
1040                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1041             SELECTION_MODE="--test"
1042             ;;
1043         *"mrr-daily"* )
1044             readarray -t test_tag_array <<< $(grep -v "#" \
1045                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
1046                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1047             SELECTION_MODE="--test"
1048             ;;
1049         *"mrr-weekly"* )
1050             readarray -t test_tag_array <<< $(grep -v "#" \
1051                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
1052                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1053             SELECTION_MODE="--test"
1054             ;;
1055         *"soak-weekly"* )
1056             readarray -t test_tag_array <<< $(grep -v "#" \
1057                 ${tfd}/soak_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
1058                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1059             SELECTION_MODE="--test"
1060             ;;
1061         *"report-iterative"* )
1062             test_sets=(${TEST_TAG_STRING//:/ })
1063             # Run only one test set per run
1064             report_file=${test_sets[0]}.md
1065             readarray -t test_tag_array <<< $(grep -v "#" \
1066                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
1067                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1068             SELECTION_MODE="--test"
1069             ;;
1070         *"report-coverage"* )
1071             test_sets=(${TEST_TAG_STRING//:/ })
1072             # Run only one test set per run
1073             report_file=${test_sets[0]}.md
1074             readarray -t test_tag_array <<< $(grep -v "#" \
1075                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
1076                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
1077             SELECTION_MODE="--test"
1078             ;;
1079         * )
1080             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1081                 # If nothing is specified, we will run pre-selected tests by
1082                 # following tags.
1083                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
1084                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
1085                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
1086                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
1087                                 "!drv_af_xdp" "!drv_avf")
1088             else
1089                 # If trigger contains tags, split them into array.
1090                 test_tag_array=(${TEST_TAG_STRING//:/ })
1091             fi
1092             SELECTION_MODE="--include"
1093             ;;
1094     esac
1095
1096     # Blacklisting certain tags per topology.
1097     #
1098     # Reasons for blacklisting:
1099     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
1100     case "${TEST_CODE}" in
1101         *"1n-vbox")
1102             test_tag_array+=("!avf")
1103             test_tag_array+=("!vhost")
1104             test_tag_array+=("!flow")
1105             ;;
1106         *"1n-alt")
1107             test_tag_array+=("!flow")
1108             ;;
1109         *"2n-clx")
1110             test_tag_array+=("!ipsechw")
1111             ;;
1112         *"2n-icx")
1113             test_tag_array+=("!ipsechw")
1114             ;;
1115         *"2n-spr")
1116             ;;
1117         *"2n-tx2")
1118             test_tag_array+=("!ipsechw")
1119             ;;
1120         *"2n-zn2")
1121             test_tag_array+=("!ipsechw")
1122             ;;
1123         *"3n-alt")
1124             test_tag_array+=("!ipsechw")
1125             ;;
1126         *"3n-icx")
1127             test_tag_array+=("!ipsechw")
1128             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
1129             ;;
1130         *"3n-snr")
1131             ;;
1132         *"3n-icxd")
1133             ;;
1134         *"3na-spr")
1135             ;;
1136         *"3nb-spr")
1137             ;;
1138         *"3n-tsh")
1139             test_tag_array+=("!drv_avf")
1140             test_tag_array+=("!ipsechw")
1141             ;;
1142         *"1n-aws" | *"2n-aws" | *"3n-aws")
1143             test_tag_array+=("!ipsechw")
1144             ;;
1145         *"2n-c7gn" | *"3n-c7gn")
1146             test_tag_array+=("!ipsechw")
1147             ;;
1148         *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
1149             test_tag_array+=("!ipsechw")
1150             ;;
1151         *"2n-x-"* | *"3n-x-"*)
1152             ;;
1153     esac
1154
1155     # We will add excluded NICs.
1156     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
1157
1158     TAGS=()
1159     prefix=""
1160     if [[ "${TEST_CODE}" != *"daily"* ]]; then
1161         if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1162             if [[ "${TEST_CODE}" != *"device"* ]]; then
1163                 # Automatic prefixing for VPP perf jobs to limit the NIC used.
1164                 if [[ "${TEST_TAG_STRING-}" != *"nic_"* ]]; then
1165                     prefix="${default_nic}AND"
1166                 fi
1167             fi
1168         fi
1169     fi
1170     set +x
1171     for tag in "${test_tag_array[@]}"; do
1172         if [[ "${tag}" == "!"* ]]; then
1173             # Exclude tags are not prefixed.
1174             TAGS+=("${tag}")
1175         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
1176             # Badly formed tag expressions can trigger way too much tests.
1177             set -x
1178             warn "The following tag expression hints at bad trigger: ${tag}"
1179             warn "Possible cause: Multiple triggers in a single comment."
1180             die "Aborting to avoid triggering too many tests."
1181         elif [[ "${tag}" == *"OR"* ]]; then
1182             # If OR had higher precedence than AND, it would be useful here.
1183             # Some people think it does, thus triggering way too much tests.
1184             set -x
1185             warn "The following tag expression hints at bad trigger: ${tag}"
1186             warn "Operator OR has lower precedence than AND. Use space instead."
1187             die "Aborting to avoid triggering too many tests."
1188         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
1189             # Empty and comment lines are skipped.
1190             # Other lines are normal tags, they are to be prefixed.
1191             TAGS+=("${prefix}${tag}")
1192         fi
1193     done
1194     set -x
1195 }
1196
1197
1198 function select_topology () {
1199
1200     # Variables read:
1201     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1202     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1203     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1204     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1205     # Variables set:
1206     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1207     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1208     # Functions called:
1209     # - die - Print to stderr and exit.
1210
1211     set -exuo pipefail
1212
1213     case_text="${NODENESS}_${FLAVOR}"
1214     case "${case_text}" in
1215         "1n_aws")
1216             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-aws*.yaml )
1217             TOPOLOGIES_TAGS="1_node_single_link_topo"
1218             ;;
1219         "1n_c6in")
1220             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-c6in*.yaml )
1221             TOPOLOGIES_TAGS="1_node_single_link_topo"
1222             ;;
1223         "1n_alt" | "1n_spr")
1224             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1225             TOPOLOGIES_TAGS="2_node_single_link_topo"
1226             ;;
1227         "1n_vbox")
1228             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1229             TOPOLOGIES_TAGS="2_node_single_link_topo"
1230             ;;
1231         "2n_aws")
1232             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-aws*.yaml )
1233             TOPOLOGIES_TAGS="2_node_single_link_topo"
1234             ;;
1235         "2n_c7gn")
1236             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c7gn*.yaml )
1237             TOPOLOGIES_TAGS="2_node_single_link_topo"
1238             ;;
1239         "2n_c6in")
1240             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c6in*.yaml )
1241             TOPOLOGIES_TAGS="2_node_single_link_topo"
1242             ;;
1243         "2n_clx")
1244             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx_*.yaml )
1245             TOPOLOGIES_TAGS="2_node_*_link_topo"
1246             ;;
1247         "2n_icx")
1248             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_icx_*.yaml )
1249             TOPOLOGIES_TAGS="2_node_*_link_topo"
1250             ;;
1251         "2n_spr")
1252             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_spr_*.yaml )
1253             TOPOLOGIES_TAGS="2_node_*_link_topo"
1254             ;;
1255         "2n_tx2")
1256             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2_*.yaml )
1257             TOPOLOGIES_TAGS="2_node_single_link_topo"
1258             ;;
1259         "2n_zn2")
1260             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2_*.yaml )
1261             TOPOLOGIES_TAGS="2_node_*_link_topo"
1262             ;;
1263         "3n_alt")
1264             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_alt_*.yaml )
1265             TOPOLOGIES_TAGS="3_node_single_link_topo"
1266             ;;
1267         "3n_aws")
1268             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-aws*.yaml )
1269             TOPOLOGIES_TAGS="3_node_single_link_topo"
1270             ;;
1271         "3n_c7gn")
1272             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c7gn*.yaml )
1273             TOPOLOGIES_TAGS="3_node_single_link_topo"
1274             ;;
1275         "3n_c6in")
1276             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c6in*.yaml )
1277             TOPOLOGIES_TAGS="3_node_single_link_topo"
1278             ;;
1279         "3n_icx")
1280             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icx_*.yaml )
1281             # Trailing underscore is needed to distinguish from 3n_icxd.
1282             TOPOLOGIES_TAGS="3_node_*_link_topo"
1283             ;;
1284         "3n_icxd")
1285             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icxd_*.yaml )
1286             TOPOLOGIES_TAGS="3_node_single_link_topo"
1287             ;;
1288         "3n_snr")
1289             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_snr_*.yaml )
1290             TOPOLOGIES_TAGS="3_node_single_link_topo"
1291             ;;
1292         "3n_tsh")
1293             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh_*.yaml )
1294             TOPOLOGIES_TAGS="3_node_single_link_topo"
1295             ;;
1296         "3na_spr")
1297             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3na_spr_*.yaml )
1298             TOPOLOGIES_TAGS="3_node_*_link_topo"
1299             ;;
1300         "3nb_spr")
1301             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3nb_spr_*.yaml )
1302             TOPOLOGIES_TAGS="3_node_*_link_topo"
1303             ;;
1304         "2n_x"*)
1305             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_"${FLAVOR}"*.yaml )
1306             TOPOLOGIES_TAGS="2_node_single_link_topo"
1307             ;;
1308         "3n_x"*)
1309             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_"${FLAVOR}"*.yaml )
1310             TOPOLOGIES_TAGS="3_node_single_link_topo"
1311             ;;
1312         *)
1313             # No falling back to default, that should have been done
1314             # by the function which has set NODENESS and FLAVOR.
1315             die "Unknown specification: ${case_text}"
1316     esac
1317
1318     if [[ -z "${TOPOLOGIES-}" ]]; then
1319         die "No applicable topology found!"
1320     fi
1321 }
1322
1323
1324 function set_environment_variables () {
1325
1326     # Depending on testbed topology, overwrite defaults set in the
1327     # resources/libraries/python/Constants.py file
1328     #
1329     # Only to be called from the reservation function,
1330     # as resulting values may change based on topology data.
1331     #
1332     # Variables read:
1333     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1334     # Variables set:
1335     # See specific cases
1336
1337     set -exuo pipefail
1338
1339     case "${TEST_CODE}" in
1340         *"1n-aws" | *"2n-aws" | *"3n-aws")
1341             export TREX_RX_DESCRIPTORS_COUNT=1024
1342             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1343             export TREX_CORE_COUNT=6
1344             # Settings to prevent duration stretching.
1345             export PERF_TRIAL_STL_DELAY=0.1
1346             ;;
1347         *"2n-c7gn" | *"3n-c7gn")
1348             export TREX_RX_DESCRIPTORS_COUNT=1024
1349             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1350             export TREX_CORE_COUNT=6
1351             # Settings to prevent duration stretching.
1352             export PERF_TRIAL_STL_DELAY=0.1
1353             ;;
1354         *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
1355             export TREX_RX_DESCRIPTORS_COUNT=1024
1356             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1357             export TREX_CORE_COUNT=6
1358             # Settings to prevent duration stretching.
1359             export PERF_TRIAL_STL_DELAY=0.1
1360             ;;
1361         *"2n-zn2")
1362             # Maciek's workaround for Zen2 with lower amount of cores.
1363             export TREX_CORE_COUNT=14
1364             ;;
1365         *"2n-x-"* | *"3n-x-"* )
1366             export TREX_CORE_COUNT=2
1367             ;;
1368     esac
1369 }
1370
1371
1372 function untrap_and_unreserve_testbed () {
1373
1374     # Use this as a trap function to ensure testbed does not remain reserved.
1375     # Perhaps call directly before script exit, to free testbed for other jobs.
1376     # This function is smart enough to avoid multiple unreservations (so safe).
1377     # Topo cleanup is executed (call it best practice), ignoring failures.
1378     #
1379     # Hardcoded values:
1380     # - default message to die with if testbed might remain reserved.
1381     # Arguments:
1382     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1383     # Variables read (by inner function):
1384     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1385     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1386     # Variables set:
1387     # - TERRAFORM_MODULE_DIR - Terraform module directory.
1388     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1389     # Trap unregistered:
1390     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1391     # Functions called:
1392     # - die - Print to stderr and exit.
1393     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1394
1395     set -xo pipefail
1396     set +eu  # We do not want to exit early in a "teardown" function.
1397     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1398     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1399     if [[ -z "${wt-}" ]]; then
1400         set -eu
1401         warn "Testbed looks unreserved already. Trap removal failed before?"
1402     else
1403         ansible_playbook "cleanup" || true
1404         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1405             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1406         }
1407         case "${TEST_CODE}" in
1408             *"1n-aws" | *"2n-aws" | *"3n-aws")
1409                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
1410                 terraform_destroy || die "Failed to call terraform destroy."
1411                 ;;
1412             *"2n-c7gn" | *"3n-c7gn")
1413                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1414                 terraform_destroy || die "Failed to call terraform destroy."
1415                 ;;
1416             *"1n-c6in" | *"2n-c6in" | *"3n-c6in")
1417                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1418                 terraform_destroy || die "Failed to call terraform destroy."
1419                 ;;
1420             *)
1421                 ;;
1422         esac
1423         WORKING_TOPOLOGY=""
1424         set -eu
1425     fi
1426 }
1427
1428
1429 function warn () {
1430
1431     # Print the message to standard error.
1432     #
1433     # Arguments:
1434     # - ${@} - The text of the message.
1435
1436     set -exuo pipefail
1437
1438     echo "$@" >&2
1439 }